//---------------------------------------------------------------------------
            
#include <vcl.h>
#pragma hdrstop

#include "LibShowUnit.h"
#include <dstring.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cad"
#pragma resource "*.dfm"
TLibShowFrm *LibShowFrm;
//---------------------------------------------------------------------------
__fastcall TLibShowFrm::TLibShowFrm(TComponent* Owner)
        : TForm(Owner)
{
LibManagers = new TList;

}
 void   TLibShowFrm::RemoveLibManager( int id)
{

    LibManagers->Remove(LibManagers->Items[id]);
/*    for (int i=id ; i <LibManagers->Count -1; i++)
      LibManagers[i]:= LibManagers[i+1];

    LibManagers[High(LibManagers)].Free;
    SetLength(LibManagers,High(LibManagers))
  */
}

//---------------------------------------------------------------------------
void __fastcall TLibShowFrm::CloseLibClick(TObject *Sender)
{
  int  id,i ;
  id=-1;
  for (i=0 ;i<LibManagers->Count; i++)

   if (((TLibManager*)(LibManagers->Items[i]))->LibFileName.Pos(PageControl->ActivePage->Caption ) >0 )
     id=i;

  if (id > -1)    RemoveLibManager(id);
  if (PageControl->ActivePage != NULL)   PageControl->ActivePage->Free();
}
//---------------------------------------------------------------------------
void __fastcall TLibShowFrm::FormDestroy(TObject *Sender)
{
  for (int  i= 0  ; i < LibManagers ->Count ;i++)
     delete  (TLibManager * )(LibManagers->Items[i]);

 delete LibManagers;

}
//---------------------------------------------------------------------------



void __fastcall TLibShowFrm::TabSheetShow(TObject *Sender)
{
  for (int  i=0 ; i<LibManagers->Count;i++)
  {
   if ( ((TLibManager*)LibManagers->Items[i])->LibFileName.Pos(
          dynamic_cast <TTabSheet *> (Sender)->Caption)>0) {
     mLibManager = (TLibManager*)(LibManagers->Items[i]);
     mListView = dynamic_cast <TListView *>(PageControl->ActivePage->Components[1]);
    }
    }
}


void TLibShowFrm::LoadLib(AnsiString LibFileName)
{
 int i ;
  Graphics::TBitmap  *ABitmap;
  TListItem *AListItem;
  TImageList * AlibImageList;
  AnsiString mCaption;


  if (IsTCADLibFile(LibFileName))
    for ( i=0 ; i < LibManagers->Count; i++)
    {
      if (LibFileName.Pos(((TLibManager*)LibManagers->Items[i])->LibFileName ) > 0)
        {
              ShowMessage("This Lib: "+ LibFileName +" has been opened!");
              return;
         }
    }
    else
      {
              ShowMessage("This Lib: "+ LibFileName +" is not a TCAD library file!");
              return;

      }

  // SetLength(LibManagers,High(LibManagers)+2);
   mLibManager  = new  TLibManager;
   mLibManager->LoadFromFile(LibFileName);
   LibManagers->Add(mLibManager);

   ATabSheet = new TTabSheet(this);
   ATabSheet->Parent = PageControl;
   ATabSheet->PageControl=  PageControl;
   LibFileName= ExtractFileName(LibFileName);

      int j =  LibFileName.Pos(".");
   ATabSheet->Caption= LibFileName.SubString(1,j-1);
   ATabSheet->OnShow =     TabSheetShow;
   PageControl->ActivePage=ATabSheet;




  AlibImageList= new TImageList(ATabSheet);
  AlibImageList->Height = 32;
  AlibImageList->Width  = 32;
  ABitmap = new Graphics::TBitmap;
  for ( i=0 ; i< mLibManager->cmbShapesCount;i++)
  {
    mCaption=   mLibManager->GetCmbShapesNameByID(i);
    mLibManager->GetCmbShapeImage(mCaption, AlibImageList->Width,ABitmap,clGray);
    AlibImageList->Add(ABitmap,NULL);

  }
  delete  ABitmap;

   AListView= new TListView(ATabSheet);
   AListView->Parent=ATabSheet;
   AListView->Align=alClient;
   AListView->ViewStyle=  vsIcon;
   AListView->IconOptions->AutoArrange=true;
   AListView->LargeImages= AlibImageList;
   AListView->Color=clGray;
   AListView->DragMode =dmAutomatic;
 //  AListView->  Clear()  ;
  for (i=0 ; i< mLibManager->cmbShapesCount ;i++)
  {
    AListItem=AListView->Items->Add();
    mCaption=  mLibManager->GetCmbShapesNameByID(i);
    AListItem->Caption=mCaption;
    AListItem->ImageIndex=i;
   }


    mListView=AListView;



  }


